VARYING vec3 pos;
//VARYING vec2 texcoord;

//TODO fix error "Shader metadata section found, but content to small to be valid!"

const float gamma = 2.2;
vec4 sRGBToLinear(vec4 srgbIn)
{
    return vec4(pow(srgbIn.rgb, vec3(gamma)), srgbIn.a);
}
vec3 sRGBToLinear(vec3 srgbIn)
{
    return pow(srgbIn.rgb, vec3(gamma));
}
float sRGBToLinear(float srgbIn)
{
    return pow(srgbIn, gamma);
}

vec3 rgb2hsv(vec3 c)
{
    vec4 K = vec4(0.0, -1.0 / 3.0, 2.0 / 3.0, -1.0);
    vec4 p = mix(vec4(c.bg, K.wz), vec4(c.gb, K.xy), step(c.b, c.g));
    vec4 q = mix(vec4(p.xyw, c.r), vec4(c.r, p.yzx), step(p.x, c.r));

    float d = q.x - min(q.w, q.y);
    float e = 1.0e-10;
    return vec3(abs(q.z + (q.w - q.y) / (6.0 * d + e)), d / (q.x + e), q.x);
}

vec3 hsv2rgb(vec3 c)
{
    vec4 K = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);
    vec3 p = abs(fract(c.xxx + K.xyz) * 6.0 - K.www);
    return c.z * mix(K.xxx, clamp(p - K.xxx, 0.0, 1.0), c.y);
}

bool matchColors(vec3 color1, vec3 color2)
{
    return (ivec3(color1 * 256) == ivec3(color2 * 256));
}

void MAIN()
{
    float alpha = length(UV0 - vec2(0.5)) * 2.0;

    alpha = alpha*alpha;

    BASE_COLOR = vec4(0.4, 0.4, 0.4, 1.0 - alpha); //sRGBToLinear(vec4(UV0, 0.0, 1.0 - alpha));

    BASE_COLOR.rgb *= BASE_COLOR.a;

    float xPos = UV0.x * 2000.0;
    xPos = xPos - int(xPos / 40.0) * 40.0 - 20.0;
    float yPos = UV0.y * 2000.0;
    yPos = yPos - int(yPos / 40.0) * 40.0 - 20.0;

    float lineAlpha1 = min(1.0, min(abs(xPos/2.0), abs(yPos/2.0)));

    xPos = UV0.x * 2000.0;
    xPos = xPos - int(xPos / 200.0) * 200.0 - 100.0;
    yPos = UV0.y * 2000.0;
    yPos = yPos - int(yPos / 200.0) * 200.0 - 100.0;

    float lineAlpha2 = min(1.0, min(abs(xPos/2.0) - 0.5, abs(yPos/2.0)- 0.5));

    BASE_COLOR.rgb = vec3(clamp(min(lineAlpha1, lineAlpha2), 0.05, 0.2));

//    METALNESS = clamp(BASE_COLOR.r, 0.0, 1.0);
//    ROUGHNESS = clamp(BASE_COLOR.r, 0.0, 1.0);

    METALNESS = 0.0;
    ROUGHNESS = 0.05;


//    BASE_COLOR = vec4(0.4, 0.4, 0.2, 1.0);
}

#include "principledMaterialFresnel.glsllib"

float qtG_GGX_2cos(float cos_theta_m, float alpha) {
    float k = 0.5 * alpha;
    return 0.5 / (cos_theta_m * (1.0 - k) + k);
}

float qtD_GGX(float cos_theta_m, float alpha) {
    float alpha2 = alpha * alpha;
    float d = 1.0 + (alpha2 - 1.0) * cos_theta_m * cos_theta_m;
    return alpha2 / (M_PI * d * d);
}

vec4 _qt_specularGGXBSDF(in vec3 normal, in vec3 L, in vec3 V, in vec3 lightSpecular, in float specularAmount, in float roughness, in float metalness, in vec3 baseColor)
{
    roughness = clamp(roughness, 0.00001, 1.0);
    float NdotL = dot(normal, L);
    float cNdotL = max(0.0, NdotL);
    float NdotV = dot(normal, V);
    float cNdotV = max(0.0, NdotV);
    vec3 H = normalize(V + L);
    float cLdotH = max(0.0, dot(L, H));
    float cNdotH = max(0.0, dot(normal, H));
    float alpha_ggx = roughness * roughness;
    float D = qtD_GGX(cNdotH, alpha_ggx);
    float G = qtG_GGX_2cos(cNdotL, alpha_ggx) * qtG_GGX_2cos(cNdotV, alpha_ggx);

    vec3 f0 = qt_F0(metalness, specularAmount, baseColor);
    float cLdotH5 = qt_schlick(cLdotH);
    vec3 F = mix(vec3(cLdotH5), vec3(1.0), f0);

    vec3 specular_brdf_NL = cNdotL * D * F * G;

    return vec4(specular_brdf_NL * lightSpecular, 1.0);
}

//void SPECULAR_LIGHT()
//{
////    float reflect = 0.0;
////    float reflectivity = 1.0;
////    vec3 H = normalize(VIEW_VECTOR + TO_LIGHT_DIR);
////    float cosAlpha = max(0.0, dot(H, normalize(NORMAL)));
////    float shine = pow(cosAlpha, exp2(15.0 * (1.0 - reflect) + 1.0) * 0.25) * reflectivity;
////    SPECULAR += shine * LIGHT_COLOR * 1.0 * SHADOW_CONTRIB * LIGHT_ATTENUATION;

//    vec3 lightSpecularColor = vec3(1.0);

//    //TODO TO_LIGHT_DIR should be replaced with (-TO_LIGHT_DIR), light direction is incorrect
//    vec3 shine2 = _qt_specularGGXBSDF(NORMAL, TO_LIGHT_DIR.xyz, VIEW_VECTOR, LIGHT_COLOR, SPECULAR_AMOUNT, ROUGHNESS, METALNESS, BASE_COLOR.rgb).rgb;
//    SPECULAR += shine2 * LIGHT_ATTENUATION * SHADOW_CONTRIB;
//}
//void SPECULAR_LIGHT()
//{
//    vec3 H = normalize(VIEW_VECTOR + TO_LIGHT_DIR);
//    float cosAlpha = max(0.0, dot(H, normalize(NORMAL)));
//    float shine = pow(cosAlpha, 2.0);
//    const vec3 specularColor = vec3(1.0);
//    SPECULAR += shine * specularColor;
//}
//void SPECULAR_LIGHT()
//{
//    vec3 lightSpecularColor(1.0);
//    //vec3 shine2 = qtspecularGGXBSDF(NORMAL, -TO_LIGHT_DIR.xyz, VIEW_VECTOR, lightSpecularColor.rgb, 1.0, ROUGHNESS, METALNESS, BASE_COLOR.rgb).rgb;
//    vec3 shine2 = qtspecularGGXBSDF(NORMAL, + TO_LIGHT_DIR.xyz, VIEW_VECTOR, vec3(1.0).rgb, 1.0, ROUGHNESS, METALNESS, BASE_COLOR.rgb).rgb;
//    //SPECULAR += qt_lightAttenuation * qt_shadow_map_occl * qt_specularTint * qt_specularGGXBSDF(qt_world_normal, -TO_LIGHT_DIR.xyz, qt_view_vector, lightSpecularColor.rgb, qt_specularFactor, qt_roughnessAmount, qt_metalnessAmount, qt_diffuseColor.rgb).rgb;
//    SPECULAR += shine2 * LIGHT_COLOR * LIGHT_ATTENUATION * SHADOW_CONTRIB;
//}
