#ifndef MODELCONTROLLER_H
#define MODELCONTROLLER_H

#include <QObject>
#include <QQuick3DObject>
#include <QQmlApplicationEngine>

class SkinGeometry;
class QQuick3DTextureData;

class ModelController : public QObject
{
    Q_OBJECT
public:
    ModelController(QQmlApplicationEngine& engine, QObject* parent = nullptr);

    Q_INVOKABLE void setRootNode(QQuick3DObject* rootNode);
    Q_INVOKABLE void loadModel();

private:
    QQuick3DObject* m_rootNode;
    QQmlApplicationEngine& m_engine;
    SkinGeometry* m_geometry;
    QQuick3DObject* m_texture;
    QQuick3DObject* m_material;
    QQuick3DTextureData* m_textureData;

};

#endif // MODELCONTROLLER_H
